//
// aofptr.cpp : Defines the entry point for the console application.
// A C++ program that demonstrates how to define and use
// arrays of pointers.
// Copyright Chris H. Pappas and William H. Murray, 2001
//

#include <cctype>
#include <fstream>
#include <iostream>
using namespace std;

#define INUMBER_OF_ERRORS 3

char *pszarray[INUMBER_OF_ERRORS] =
          {
            "\nFile not available.\n",
            "\nNot an alpha character.\n",
            "\nValue not between 1 and 10.\n"
          };

void fopen_a_file(char *psz);
char cget_a_char(void);
int iget_an_integer(void);

ifstream pfa_file;

int main(int argc, char* argv[])
{
  char cvalue;
  int ivalue;

  fopen_a_file("input.dat");
  cvalue = cget_a_char( );
  ivalue = iget_an_integer( );

  return 0;
}

void fopen_a_file(char *psz)
{
  const ifopen_a_file_error = 0;

  pfa_file.open(psz);
  if(!pfa_file)
    cout << pszarray[ifopen_a_file_error];
}

char cget_a_char(void)
{
  char cvalue;
  const icget_a_char_error = 1;

  cout << "\nEnter a character: ";
  cin >> cvalue;
  if(!isalpha(cvalue))
    cout << pszarray[icget_a_char_error];
  return(cvalue);
}

int iget_an_integer(void)
{
  int ivalue;
  const iiget_an_integer = 2;
  cout << "\nEnter an integer between 1 and 10: ";
  cin >> ivalue;
  if( (ivalue < 1) || (ivalue > 10) )
    cout << pszarray[iiget_an_integer];
  return(ivalue);
}