//
// dblptr.cpp : Defines the entry point for the console application.
// A C++ program using pointer variables with double indirection
//  Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include <iostream>
#include <cstdlib>
using namespace std;

#define IMAXELEMENTS 3

void voutput(int **ppiresult_a, int **ppiresult_b, 
             int **ppiresult_c);
void vassign(int *pivirtual_array[],int *pinewblock);

int main(int argc, char* argv[])
{
  int **ppiresult_a, **ppiresult_b, **ppiresult_c;
  int *pivirtual_array[IMAXELEMENTS];
  int *pinewblock, *pioldblock;

  ppiresult_a = &pivirtual_array[0];
  ppiresult_b = &pivirtual_array[1];
  ppiresult_c = &pivirtual_array[2];

  pinewblock = new int[IMAXELEMENTS];
  pioldblock = pinewblock;

  vassign(pivirtual_array,pinewblock);

  **ppiresult_a = 7;
  **ppiresult_b = 10;
  **ppiresult_c = 15;

  voutput(ppiresult_a,ppiresult_b,ppiresult_c);

  pinewblock = new int[IMAXELEMENTS];

  *pinewblock = **ppiresult_a;
  *(pinewblock+1) = **ppiresult_b;
  *(pinewblock+2) = **ppiresult_c;

  free(pioldblock);

  vassign(pivirtual_array,pinewblock);

  voutput(ppiresult_a,ppiresult_b,ppiresult_c);

  return 0;
}

void vassign(int *pivirtual_array[],int *pinewblock)
{
  pivirtual_array[0] = pinewblock;
  pivirtual_array[1] = pinewblock+1;
  pivirtual_array[2] = pinewblock+2;
}

void voutput(int **ppiresult_a, int **ppiresult_b, int **ppiresult_c)
{
  cout << **ppiresult_a << endl;
  cout << **ppiresult_b << endl;
  cout << **ppiresult_c << endl;
}