//
// voidptr.cpp : Defines the entry point for the console application.
// A C++ program using void pointers
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include <iostream>
using namespace std;

#define ISTRING_MAX 50

void voutput(void *pobject, char cflag);

int main(int argc, char* argv[])
{
  int *pi;
  char *psz;
  float *pf;
  char cresponse,cnewline;

  cout << "Please enter the dynamic data type\n";
  cout << "    you would like to create.\n\n";
  cout << "Use (s)tring, (i)nt, or (f)loat "; 
  cin >> cresponse;
    cin.get(cnewline);
      switch(cresponse) {
        case 's':
          psz=new char[ISTRING_MAX];
          cout << "\nPlease enter a string: "; 
          cin.get(psz,ISTRING_MAX); 
          voutput(psz,cresponse);
          break;
        case 'i':
          pi=new int;
          cout << "\nPlease enter an integer: "; 
          cin >> *pi;
          voutput(pi,cresponse);
          break;
        case 'f':
          pf=new float;
          cout << "\nPlease enter a float: ";
          cin >> *pf; voutput(pf,cresponse);
          break;
        default:
          cout << "\n\n  Object type not implemented!";
     }

  cout << endl;

  return 0;
}
void voutput(void *pobject, char cflag)
{
  switch(cflag) {
    case 's':
      cout << "\nThe string read in:  " << (char *) pobject; 
      delete pobject;
      break;
    case 'i':
      cout << "\nThe integer read in: " 
           << *((int *) pobject); 
      delete pobject;
      break;
    case 'f':
      cout << "\nThe float value read in: "  
           << *((float *) pobject);
      delete pobject;
      break;
     }
}